# coding: utf-8

"""
    Klavis AI (https://www.klavis.ai)

    Klavis AI - Open Source MCP Integrations for AI Applications

    The version of the OpenAPI document: 0.1.0
    Contact: connect@klavis.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetInstanceResponse(BaseModel):
    """
    GetInstanceResponse
    """ # noqa: E501
    instance_id: Optional[StrictStr] = Field(default=None, alias="instanceId")
    is_authenticated: Optional[StrictBool] = Field(default=False, description="Indicates whether the instance is authenticated successfully.", alias="isAuthenticated")
    server_name: Optional[StrictStr] = Field(default='', description="The name of the MCP server associated with the instance.", alias="serverName")
    platform: Optional[StrictStr] = Field(default='', description="The platform associated with the instance (e.g., 'Den', 'CamelAI').")
    external_user_id: Optional[StrictStr] = Field(default='', description="The user's identifier on the external platform.", alias="externalUserId")
    __properties: ClassVar[List[str]] = ["instanceId", "isAuthenticated", "serverName", "platform", "externalUserId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetInstanceResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if instance_id (nullable) is None
        # and model_fields_set contains the field
        if self.instance_id is None and "instance_id" in self.model_fields_set:
            _dict['instanceId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetInstanceResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "instanceId": obj.get("instanceId"),
            "isAuthenticated": obj.get("isAuthenticated") if obj.get("isAuthenticated") is not None else False,
            "serverName": obj.get("serverName") if obj.get("serverName") is not None else '',
            "platform": obj.get("platform") if obj.get("platform") is not None else '',
            "externalUserId": obj.get("externalUserId") if obj.get("externalUserId") is not None else ''
        })
        return _obj


